#include <stdio.h>

int main( void )
{
    int a[10] = {0,1,2,3,4,5,6,7,8,9};
    int i;

    int b[10];
    #pragma omp parallel
    {
    #pragma omp for
    for (i = 0; i < 9; i++)
      b[i] = a[i];
    #pragma omp for
    for (i = 0; i < 9; i++)
        a[i] = b[i+1] + i; // f(i) -> i
    }

    #pragma omp parallel
    {
      int nthr = omp_get_num_threads();
      int tid = omp_get_thread_num();
      int chunk = 9 / nthr;
      int istart = chunk * tid;
      int iend = istart + chunk;
      if (tid == nthr - 1) iend = 9;
      //a[iend - 1] = a[iend] + iend - 1;
      double a_iend = a[iend];
      #pragma omp barrier
      a[iend - 1] = a_iend + iend - 1;
      for (int i = istart; i < iend - 1; i++)
        a[i] = a[i+1] + i;
    }

    //  1  3  5  7  9  11  13  15  17  9 
    for (i = 0; i < 10; i++)
        printf(" %d ", a[i]);
    printf("\n");

    return 0;
}
